package javax.naming.directory;

import javax.naming.NamingException;
import javax.naming.NamingEnumeration;
import java.io.Serializable;

public interface Attribute extends Cloneable, Serializable
{
    public static final long serialVersionUID = 8707690322213556804L;
    
    public abstract NamingEnumeration<?> getAll() throws NamingException;
    
    public abstract Object get() throws NamingException;
    
    public abstract int size();
    
    public abstract String getID();
    
    public abstract boolean contains(Object p0);
    
    public abstract boolean add(Object p0);
    
    public abstract boolean remove(Object p0);
    
    public abstract void clear();
    
    public abstract DirContext getAttributeSyntaxDefinition() throws NamingException;
    
    public abstract DirContext getAttributeDefinition() throws NamingException;
    
    public abstract Object clone();
    
    public abstract boolean isOrdered();
    
    public abstract Object get(int p0) throws NamingException;
    
    public abstract Object remove(int p0);
    
    public abstract void add(int p0, Object p1);
    
    public abstract Object set(int p0, Object p1);
}
